



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【POI   word】使用POI实现对Word的读取以及生成</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【POI   word】使用POI实现对Word的读取以及生成</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 07:36:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>项目结构如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/978388/201607/978388-20160715120046123-1767363042.png" /></p>
<p>那<strong>第一部分：先是读取Word文档</strong></p>
<div>
<div>
<pre class="prettyprint linenums"> package com.it.WordTest;

 import java.io.FileInputStream;<br />
 import java.io.FileNotFoundException;<br />
 import java.io.FileOutputStream;<br />
 import java.io.FileWriter;<br />
 import java.io.IOException;<br />
 import java.io.Writer;<br />
 import java.util.Date;<br />
 import java.util.List;

 import org.apache.poi.POIXMLProperties.CoreProperties;<br />
 import org.apache.poi.xwpf.extractor.XWPFWordExtractor;<br />
 import org.apache.poi.xwpf.usermodel.XWPFDocument;<br />
 import org.apache.poi.xwpf.usermodel.XWPFParagraph;<br />
 import org.apache.poi.xwpf.usermodel.XWPFTable;<br />
 import org.apache.poi.xwpf.usermodel.XWPFTableCell;<br />
 import org.apache.poi.xwpf.usermodel.XWPFTableRow;<br />
 import org.openxmlformats.schemas.wordprocessingml.x2006.main.CTPPr;<br />
 import org.openxmlformats.schemas.wordprocessingml.x2006.main.CTTblPr;

 /**<br />
  * 读取docx文件<br />
  * @author Administrator<br />
  *POI在读写word docx文件时是通过xwpf模块来进行的，其核心是XWPFDocument。一个XWPFDocument代表一个docx文档，其可以用来读docx文档，也可以用来写docx文档。<br />
  *XWPFDocument中主要包含下面这几种对象：<br />
  *XWPFParagraph：代表一个段落。<br />
  *XWPFRun：代表具有相同属性的一段文本。<br />
  *XWPFTable：代表一个表格。<br />
  *XWPFTableRow：表格的一行。<br />
  *XWPFTableCell：表格对应的一个单元格。<br />
  */<br />
 public class ReadWord {

     /**<br />
      * 通过XWPFWordExtractor读取word文档<br />
      * 只能获取到文本，不能获取到文本对应的属性值<br />
      */<br />
     public static void readByXWPFWordExtractor(){<br />
         try {<br />
             FileInputStream input = new FileInputStream("f:/test/肥胖早知道模板.docx");<br />
             XWPFDocument doc = new XWPFDocument(input);<br />
             XWPFWordExtractor docE = new XWPFWordExtractor(doc);<br />
             String  text = docE.getText();<br />
             //将读取到文档中的文本信息，存放在一个txt文件中<br />
             FileWriter write = new FileWriter("f:/test/肥胖早知道的文本信息.txt");<br />
             write.write(text);<br />
             write.close();

             //获取文档的附属信息<br />
             CoreProperties coreP = docE.getCoreProperties();<br />
             //打印文档的分类信息<br />
             System.out.println(coreP.getCategory());<br />
             //打印创建者信息<br />
             System.out.println(coreP.getCreator());<br />
             //打印创建时间<br />
             System.out.println(coreP.getCreated());<br />
             //打印标题<br />
             System.out.println(coreP.getTitle());

             input.close();<br />
         } catch (FileNotFoundException e) {<br />
             e.printStackTrace();<br />
         } catch (IOException e) {<br />
             e.printStackTrace();<br />
         }<br />
     }

     /**<br />
      * 通过XWPFDocument读取word文档<br />
      * 通过XWPFDocument读取docx文档时，我们就可以获取到文本比较精确的属性信息了。比如我们可以获取到某一个XWPFParagraph、XWPFRun或者是某一个XWPFTable，包括它们对应的属性信息<br />
      */<br />
     public static void readByXWPFDocument(){<br />
         Date data = new Date();<br />
         try {<br />
             FileInputStream inputStream = new FileInputStream("f:/test/肥胖早知道模板.docx");<br />
             XWPFDocument doc =new XWPFDocument(inputStream);<br />
             //获取所有段落<br />
             List&lt;XWPFParagraph&gt; list = doc.getParagraphs();<br />
             FileWriter writer = new FileWriter("f:/test/肥胖早知道 带属性.txt");<br />
             StringBuffer str = new StringBuffer();<br />
             for (XWPFParagraph xwpfParagraph : list) {<br />
                 //获取当前段落的属性<br />
                 CTPPr CPPR = xwpfParagraph.getCTP().getPPr();<br />
                 str.append(xwpfParagraph.getText());<br />
             }<br />
             writer.write(str.toString());

             //获取多有table<br />
             List&lt;XWPFTable&gt; tableList = doc.getTables();<br />
             List&lt;XWPFTableRow&gt; rowList;<br />
             List&lt;XWPFTableCell&gt; cellList;<br />
             StringBuilder build = new StringBuilder();<br />
             for (XWPFTable xwpfTable : tableList) {<br />
                 //获取表格信息<br />
                 CTTblPr  tablePer = xwpfTable.getCTTbl().getTblPr();<br />
                 //获取表格相对应的行<br />
                 rowList =xwpfTable.getRows();<br />
                 for (XWPFTableRow xwpfTableRow : rowList) {<br />
                     cellList = xwpfTableRow.getTableCells();<br />
                     for (XWPFTableCell xwpfTableCell : cellList) {<br />
                         build.append("【单元格信息】："+xwpfTableCell.getText()+"\r\n");<br />
                     }<br />
                 }<br />
             }<br />
             writer.append(build);<br />
             writer.close();

             inputStream.close();

             Date date2 = new Date();<br />
             System.out.println("消耗时间:"+(date2.getTime()-data.getTime())+"ms");<br />
         } catch (FileNotFoundException e) {<br />
             e.printStackTrace();<br />
         } catch (IOException e) {<br />
             e.printStackTrace();<br />
         }<br />
     }

     public static void main(String[] args) {<br />
         //readByXWPFWordExtractor();<br />
         readByXWPFDocument();<br />
     }<br />
 }</pre>
</div>
</div>
<p>在读取到word的附属信息，会在控制台打印如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/978388/201607/978388-20160715120202404-386552467.png" /></p>
<p><strong>第二部分：生成Word</strong></p>
<div>
<div>
<pre class="prettyprint linenums"> package com.it.WordTest;

 import java.io.FileNotFoundException;<br />
 import java.io.FileOutputStream;<br />
 import java.io.IOException;<br />
 import java.math.BigInteger;<br />
 import java.util.List;

 import org.apache.poi.xwpf.usermodel.XWPFDocument;<br />
 import org.apache.poi.xwpf.usermodel.XWPFParagraph;<br />
 import org.apache.poi.xwpf.usermodel.XWPFRun;<br />
 import org.apache.poi.xwpf.usermodel.XWPFTable;<br />
 import org.apache.poi.xwpf.usermodel.XWPFTableCell;<br />
 import org.apache.poi.xwpf.usermodel.XWPFTableRow;<br />
 import org.openxmlformats.schemas.wordprocessingml.x2006.main.CTPPr;<br />
 import org.openxmlformats.schemas.wordprocessingml.x2006.main.CTTblPr;<br />
 import org.openxmlformats.schemas.wordprocessingml.x2006.main.CTTblWidth;<br />
 import org.openxmlformats.schemas.wordprocessingml.x2006.main.CTTcPr;<br />
 import org.openxmlformats.schemas.wordprocessingml.x2006.main.CTTrPr;<br />
 import org.openxmlformats.schemas.wordprocessingml.x2006.main.STVerticalJc;

 public class WriteWord {

     public static void writeXWPFDocument(){

         try {<br />
             //创建一个word文档<br />
             XWPFDocument xwpfDocument = new XWPFDocument();<br />
             FileOutputStream outputStream  = new FileOutputStream("F:/test/word1.docx");<br />
             /**<br />
              * 创建一个段落<br />
              */<br />
             XWPFParagraph paragraph = xwpfDocument.createParagraph();<br />
             XWPFRun run = paragraph.createRun();<br />
             run.setText("德玛西亚！！");<br />
             //加粗<br />
             run.setBold(true);

             run = paragraph.createRun();<br />
             run.setText("艾欧尼亚");<br />
             run.setColor("fff000");

             /**<br />
              * 创建一个table<br />
              */<br />
             //创建一个10行10列的表格<br />
             XWPFTable table =xwpfDocument.createTable(10, 10);<br />
             //添加新的一列<br />
             table.addNewCol();<br />
             //添加新的一行<br />
             table.createRow();<br />
             //获取表格属性<br />
             CTTblPr tablePr = table.getCTTbl().addNewTblPr();<br />
             //获取表格宽度<br />
             CTTblWidth tableWidth = tablePr.addNewTblW();<br />
             //设置表格的宽度大小<br />
             tableWidth.setW(BigInteger.valueOf(8000));

             /**<br />
              * 获取表格中的行  以及设计行样式<br />
              */<br />
             //获取表格中的所有行<br />
             List&lt;XWPFTableRow&gt; rowList = table.getRows();<br />
             XWPFTableRow row;<br />
             row = rowList.get(0);<br />
             row.setHeight(2000);<br />
             //为这一行增加一列<br />
             row.addNewTableCell();<br />
             //获取行属性<br />
             CTTrPr rowPr = row.getCtRow().addNewTrPr();<br />
             row.getCtRow();

             /**<br />
              * 获取表格中的列  以及设计列样式<br />
              */<br />
             //获取某个单元格<br />
             XWPFTableCell cell ;<br />
             cell = row.getCell(0);<br />
             cell.setText("第一行\r\n第一列");<br />
             //单元格背景颜色<br />
             cell.setColor("676767");<br />
             //获取单元格样式<br />
             CTTcPr cellPr = cell.getCTTc().addNewTcPr();<br />
             //表格内容垂直居中<br />
             cellPr.addNewVAlign().setVal(STVerticalJc.CENTER);<br />
             //设置单元格的宽度<br />
             cellPr.addNewTcW().setW(BigInteger.valueOf(5000));

             xwpfDocument.write(outputStream);<br />
             outputStream.close();

         } catch (FileNotFoundException e) {<br />
             e.printStackTrace();<br />
         } catch (IOException e) {<br />
             e.printStackTrace();<br />
         }<br />
     }<br />
     public static void main(String[] args) {<br />
         writeXWPFDocument();<br />
     }<br />
 }</pre>
</div>
</div>
<p>生成word如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/978388/201607/978388-20160715120330264-976179435.png" /></p>
<p>唯一的感觉就是 功能实现的太简单，没有涉及到核心的部分，感觉 不美丽！！！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7egj19.html">There is insufficient system memory to run this query 错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93gj308.html">各种排序算法的分析及java实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q71r6xq.html">c&sol;s 与b&sol;s构架</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jozzgq.html">Data Science at the Command Line学习笔记（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/390w1x4q.html">Mysql 按行dump出数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdoxk38.html">两个C&plus;&plus;对象是否相等，要程序员自己下定义，通常是覆盖&equals;&equals;操作符</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde2p109.html">AndroidManifest&period;xml 文件里面的内容介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8memyz0q.html">COM组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpgorjq.html">Windows noinstall zip 安装MySQL。</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zjeye9.html">http请求HttpClient短信接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey70gx9.html">Centos下&lowbar;MysqL5&period;7在使用mysqldump命令备份数据库报错：mysqldump&colon; &lbrack;Warning&rsqb; Using a password on the command line interface can be insecure&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj6l0k8.html">Git各个状态之间转换指令总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvde3j8.html">Matplotlib学习---matplotlib的一些基本用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy4lzn9.html">简单了解weblogic配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zylj6d9.html">【多线程】Task</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjeko28.html">epoll的两种工作模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvnpo2q.html">微软 IIS HTTP&period;sys漏洞原理学习以及POC</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p12peq.html">使用awk分割字符串并且获取分割后的最后一个字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvey5kx9.html">vue实现随机验证码功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnvkyeq.html">【Python入门学习】列表生成和函数生成器的方式实现杨辉三角</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8owm5l9.html">STL&colon;原地归并排序模板（InplaceMergeSort）</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r3vvd9.html">后台session过期，tomcat重启，自动跳转页面js写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxrp2zq.html">用Mybatis返回Map&comma;List&amp;lt&semi;Map&amp;gt&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql2y3k8.html">数据库的日志数据库&lpar;&lowbar;log&period;ldf&rpar;文件太大，如何压缩</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxr130q.html">php原型模式的研究</a>
			</li>
						<li><a href="https://www.batexi.com/a/495v5gmq.html">UDP-C&num;代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/m962j54q.html">sqlplus 设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd10r7q.html">chaper3&lowbar;exerise&lowbar;Uva1368&lowbar;DNA序列</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p6jp7q.html">springmvc中RedirectAttributes的作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwpj7z8.html">sqlserver 连接远程数据库小结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
